<script setup lang="ts">
import { useUserStore } from "@/stores";
import BootstrapToast from "@/components/BootstrapToast.vue";
import DeleteUserModal from "@/components/modals/DeleteUserModal.vue";
import { environment } from "@/environment.ts";
import { onMounted } from "vue";
import { Toast } from "bootstrap";
import {
  type AuthKickstartAccountConnectionData,
  OidcProvider,
} from "@/client/types.gen.ts";
import { client } from "@/client/client.gen.ts";
import dayjs from "dayjs";

const userRepository = useUserStore();
const props = defineProps<{
  linkSuccess?: boolean;
  linkError?: string;
}>();
let successToast: Toast;
let errorToast: Toast;

function deleteCurrentUser(uid: string) {
  userRepository.deleteUser(uid).then(() => {
    alert("Your account was deleted. You will be redirect to the home page.");
    window.location.replace(`${environment.API_BASE_URL}/auth/logout`);
  });
}

function linkAccountPath(provider: OidcProvider): string {
  const config: AuthKickstartAccountConnectionData = {
    url: "/auth/account/connect/{provider}",
    path: {
      provider: provider,
    },
  };
  return (
    environment.API_BASE_URL +
    client.buildUrl<AuthKickstartAccountConnectionData>(config)
  );
}

onMounted(() => {
  successToast = Toast.getOrCreateInstance("#profile-success-toast");
  if (props.linkSuccess) {
    successToast?.show();
  }
  errorToast = Toast.getOrCreateInstance("#profile-error-toast");
  if (props.linkError) {
    errorToast?.show();
  }
});
</script>

<template>
  <bootstrap-toast toast-id="profile-success-toast" color-class="success"
    >Successfully linked your account with a new AAI provider
  </bootstrap-toast>
  <bootstrap-toast toast-id="profile-error-toast" color-class="danger">
    <template #default>Error linking your accounts</template>
    <template #body>
      <p>
        There has been some kind of error during the account linking.<br />
        Please try again later or contact the support.
      </p>
      <p>Error Code: {{ props.linkError }}</p>
    </template>
  </bootstrap-toast>
  <delete-user-modal
    modal-id="profile-delete-user-modal"
    :user="userRepository.user ?? { display_name: '', uid: '' }"
    @confirm-delete="deleteCurrentUser"
  />
  <div class="border-bottom mb-4">
    <h2 class="mb-2">My Profile</h2>
  </div>
  <div class="px-1">
    <div class="d-flex justify-content-start column-gap-4">
      <div class="text-center w-fit">
        <img
          v-if="userRepository.user"
          :src="userRepository.user.gravatar_url + '?d=mp&s=128'"
          class="rounded-circle img-fluid"
          height="128"
          width="128"
          alt="profile picture"
        />
        <div><a href="https://gravatar.com">Change</a></div>
      </div>
      <div>
        Name: {{ userRepository.user?.display_name }}<br />
        Email: {{ userRepository.user?.email }}<br />
        CloWM ID: {{ userRepository.currentUID }}<br />
        <span v-if="userRepository.user?.last_login"
          >Last Login:
          {{
            dayjs
              .unix(userRepository.user?.last_login)
              .format("MMM DD, YYYY HH:mm")
          }}</span
        >
      </div>
    </div>
    <div>
      <div class="border-bottom mb-2 mt-4">
        <h3>My linked accounts</h3>
      </div>
      <div>
        <h5>
          <a href="https://lifescience-ri.eu/ls-login/">Life Science Login</a>
        </h5>
        <p>
          The Life Science Login enables researchers to use their home
          organisation credentials or community or other identities (e.g.
          Google, Linkedin, LS ID) to sign in and access data and services they
          need. It also allows service providers (both in academia and industry)
          to control and manage access rights of their users and create
          different access levels for research groups or international projects.
        </p>
        <div v-if="userRepository.user?.lifescience_id">
          <b>Linked account: </b>
          <a href="https://profile.aai.lifescience-ri.eu/profile"
            >{{
              userRepository.user?.lifescience_id
            }}&#x200B;@lifescience-ri.eu</a
          >
        </div>
        <div v-else>
          <div>Connect with LifeScience</div>
          <div class="my-2">
            <a :href="linkAccountPath(OidcProvider.LIFESCIENCE_AAI)">
              <img
                src="/src/assets/images/ls-login.png"
                alt="[LS Login]"
                class="img-fluid"
                style="max-height: 60px"
              />
            </a>
          </div>
        </div>
      </div>
      <div>
        <h5 class="mt-2">
          <a href="https://base4nfdi.de/projects/iam4nfdi">NFDI AAI</a>
        </h5>
        <p>
          By connecting and expanding Identity and Access Management (IAM)
          systems, the IAM4NFDI initiative enables researchers across Germany
          and worldwide to seamlessly access tools, data, and services within
          the National Research Data Infrastructure (NFDI).
        </p>
        <div v-if="userRepository.user?.nfdi_id">
          <b>Linked account: </b>{{ userRepository.user?.nfdi_id }}
        </div>
        <div v-else>
          <div>Link your account with NFDI AAI</div>
          <div class="my-2">
            <a :href="linkAccountPath(OidcProvider.NFDI_AAI)">
              <img
                src="/src/assets/images/nfdi-aai.png"
                alt="[NFDi AAI]"
                class="img-fluid"
                style="max-height: 60px"
              />
            </a>
          </div>
        </div>
      </div>
    </div>
    <div>
      <div class="border-bottom mb-2 mt-4">
        <h3>My roles</h3>
      </div>
      <p>
        CloWM uses
        <a href="https://en.wikipedia.org/wiki/Role-based_access_control"
          >role-based access control (RBAC)</a
        >
        to authorize each request from a user. For each role that a user has, he
        is allowed to do certain actions on the platform.<br />
        Write an email to
        <a href="mailto:support@clowm.bi.denbi.de">support@clowm.bi.denbi.de</a>
        to request additional roles.
      </p>
      <div>Your roles:</div>
      <div class="ms-3">
        <div class="form-check">
          <input
            id="profile-user-role-checkbox"
            class="form-check-input"
            type="checkbox"
            disabled
            checked
          />
          <label
            class="form-check-label opacity-100"
            for="profile-user-role-checkbox"
          >
            <b>Base User</b>: Upload & download data to your bucket and start
            workflow executions.
          </label>
        </div>
        <div class="form-check">
          <input
            id="profile-user-role-checkbox"
            class="form-check-input"
            type="checkbox"
            disabled
            :checked="userRepository.normalUser"
          />
          <label
            class="form-check-label opacity-100"
            for="profile-user-role-checkbox"
          >
            <b>Verified User</b>: Create additional buckets with increased
            quotas and share them with other users.
          </label>
        </div>
        <div class="form-check">
          <input
            id="profile-user-role-checkbox"
            class="form-check-input"
            type="checkbox"
            disabled
            :checked="userRepository.workflowDev"
          />
          <label
            class="form-check-label opacity-100"
            for="profile-user-role-checkbox"
          >
            <b>Workflow Developer</b>: Register workflows, manage them and track
            their KPIs
          </label>
        </div>
        <div class="form-check">
          <input
            id="profile-user-role-checkbox"
            class="form-check-input"
            type="checkbox"
            disabled
            :checked="userRepository.resourceMaintainer"
          />
          <label
            class="form-check-label opacity-100"
            for="profile-user-role-checkbox"
          >
            <b>Resource Maintainer</b>: Register resources and make them
            available to workflow executions
          </label>
        </div>
        <div class="form-check">
          <input
            id="profile-user-role-checkbox"
            class="form-check-input"
            type="checkbox"
            disabled
            :checked="userRepository.reviewer"
          />
          <label
            class="form-check-label opacity-100"
            for="profile-user-role-checkbox"
          >
            <b>Reviewer</b>: Review registered workflows and resources before
            their publication.
          </label>
        </div>
        <div class="form-check">
          <input
            id="profile-user-role-checkbox"
            class="form-check-input"
            type="checkbox"
            disabled
            :checked="userRepository.admin"
          />
          <label
            class="form-check-label opacity-100"
            for="profile-user-role-checkbox"
          >
            <b>Administrator</b>: Administer this CloWM instance.
          </label>
        </div>
      </div>
    </div>
    <div>
      <div class="border-bottom mb-2 mt-4">
        <h3 class="text-danger">Delete my account</h3>
      </div>
      <p>
        This action deletes your account and you lose access to everything in
        CloWM that is connected to it. <b>There is no going back.</b>
      </p>
      <button
        role="button"
        class="btn btn-danger"
        data-bs-toggle="modal"
        data-bs-target="#profile-delete-user-modal"
      >
        Delete account
      </button>
    </div>
  </div>
</template>

<style scoped></style>
